package com.rf.kjb.scale.dao.model;

import com.rf.kjb.base.model.BaseEntry;
import lombok.*;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Author:zzf
 * @Date:2023/6/7:09:55
 * @Description:
 */
@Entity
@Data
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "t_game_record_info")
@org.hibernate.annotations.Table(appliesTo = "t_game_record_info", comment = "游戏记录")
@DynamicUpdate
public class GameRecordEntity extends BaseEntry {

    @Column(name = "type" ,columnDefinition = "varchar(2) not null  comment '1是单人模式 2是双人模式'")
    private String type;

    @Column(name = "game_scene",columnDefinition = "varchar(255) not null comment '游戏场景'")
    private String gameScene;

    @Column(name = "equipment_type",columnDefinition = "varchar(10) not null comment '设备类型:心电、脑电'")
    private String equipmentType;

    @Column(name = "game_difficulty",columnDefinition = "varchar(20) not null comment '游戏难度'")
    private String  gameDifficulty;

    @Column(name = "game_time",columnDefinition = "varchar(20) not null comment '游戏时间'")
    private String gameTime;

    @Column(name = "target_type" ,columnDefinition = "varchar(10) not null  comment '选择的指标'")
    private String targetType;

    @Column(name = "num1",columnDefinition = "varchar(20) not null comment '第一个人的编号'")
    private String num1;

    @Column(name = "num2",columnDefinition = "varchar(20) null comment '第二个人的编号'")
    private String num2;

    @Column(name = "animation_source_list1",columnDefinition = "text not null comment '第一个人的原始数据'")
    private String animationSourceList1;

    @Column(name = "animation_source_list2",columnDefinition = "text null comment '第二个人的原始数据'")
    private String animationSourceList2;

    @Column(name = "animation_target1",columnDefinition = "text not null comment '显示指标数据1'")
    private String animationTarget1;

    @Column(name = "animation_target2",columnDefinition = "text null comment '显示指标数据2'")
    private String animationTarget2;

    @Column(name = "file_name1",columnDefinition = "varchar(100) not null comment '文件名1'")
    private String fileName1;

    @Column(name = "file_name2",columnDefinition = "varchar(100) null comment '文件名2'")
    private String fileName2;

    @Column(name = "saveTime" ,columnDefinition = "varchar(50) not null  comment '保存数据的时间'")
    private String saveTime;

}
